"use strict";
"use client";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Highlight = void 0;
const react_1 = __importDefault(require("react"));
require("../style/Highlight.css");
const Highlight = (props) => {
    const { position, onClick, onMouseOver, onMouseOut, comment, isScrolledTo } = props;
    const { rects, boundingRect } = position;
    return (react_1.default.createElement("div", { className: `Highlight ${isScrolledTo ? "Highlight--scrolledTo" : ""}` },
        comment ? (react_1.default.createElement("div", { className: "Highlight__emoji", style: {
                left: 20,
                top: boundingRect.top,
            } }, comment.emoji)) : null,
        react_1.default.createElement("div", { className: "Highlight__parts" }, rects.map((rect, index) => (react_1.default.createElement("div", { onMouseOver: onMouseOver, onMouseOut: onMouseOut, onClick: onClick, key: index, style: rect, className: `Highlight__part` }))))));
};
exports.Highlight = Highlight;
//# sourceMappingURL=Highlight.js.map