"use strict";
"use client";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MouseMonitor = void 0;
const react_1 = __importStar(require("react"));
const MouseMonitor = ({ onMoveAway, paddingX, paddingY, children, }) => {
    const container = (0, react_1.useRef)(null);
    const onMouseMove = (event) => {
        if (!container)
            return;
        let current = container.current;
        if (!current)
            return;
        const { clientX, clientY } = event;
        const { left, top, width, height } = current.getBoundingClientRect();
        const inBoundsX = clientX > left - paddingX && clientX < left + width + paddingX;
        const inBoundsY = clientY > top - paddingY && clientY < top + height + paddingY;
        const isNear = inBoundsX && inBoundsY;
        if (!isNear) {
            onMoveAway();
        }
    };
    (0, react_1.useEffect)(() => {
        if (!container.current)
            return;
        let current = container.current;
        const { ownerDocument: doc } = current;
        doc.addEventListener("mousemove", onMouseMove);
        return () => {
            doc.removeEventListener("mousemove", onMouseMove);
        };
    }, [container]);
    return (react_1.default.createElement("div", { ref: container }, react_1.default.cloneElement(children, onMoveAway, paddingX, paddingY)));
};
exports.MouseMonitor = MouseMonitor;
//# sourceMappingURL=MouseMonitor.js.map