"use strict";
"use client";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PdfLoader = void 0;
const react_1 = __importStar(require("react"));
const pdfjs_dist_1 = require("pdfjs-dist");
const PdfLoader = (_a) => {
    var { workerSrc = "https://unpkg.com/pdfjs-dist@3.3.122/build/pdf.worker.min.js", url, beforeLoad, children, cMapUrl, cMapPacked, onError } = _a, props = __rest(_a, ["workerSrc", "url", "beforeLoad", "children", "cMapUrl", "cMapPacked", "onError"]);
    const [pdfDocument, setPdfDocument] = react_1.default.useState(null);
    const [error, setError] = react_1.default.useState(null);
    const documentRef = react_1.default.useRef(null);
    (0, react_1.useEffect)(() => {
        setPdfDocument(null);
        setError(null);
        if (typeof workerSrc === "string") {
            pdfjs_dist_1.GlobalWorkerOptions.workerSrc = workerSrc;
        }
        Promise.resolve()
            .then(() => pdfDocument && pdfDocument.destroy())
            .then(() => {
            if (!url) {
                return;
            }
            return (0, pdfjs_dist_1.getDocument)(Object.assign({ url,
                cMapUrl,
                cMapPacked }, props))
                .promise.then((pdfDocument) => {
                setPdfDocument(pdfDocument);
            })
                .catch((e) => {
                setError(e);
            });
        })
            .catch((e) => setError(e));
        return () => {
            if (pdfDocument) {
                pdfDocument.destroy();
            }
        };
    }, [url]);
    const renderDocument = () => {
        if (error === null && pdfDocument === null) {
            return beforeLoad;
        }
        else if (error) {
            console.log(error.message);
            return react_1.default.createElement("div", { style: { color: "black" } }, error.message);
        }
        else if (pdfDocument !== null && pdfDocument !== undefined) {
            return children(pdfDocument);
        }
        else {
            return null;
        }
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("span", { ref: documentRef }),
        renderDocument()));
};
exports.PdfLoader = PdfLoader;
//# sourceMappingURL=PdfLoader.js.map