"use strict";
"use client";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TipContainer = void 0;
const react_1 = __importStar(require("react"));
const clamp = (value, left, right) => Math.min(Math.max(value, left), right);
const TipContainer = (props) => {
    const { children, style, scrollTop, pageBoundingRect } = props;
    const [height, setHeight] = react_1.default.useState(0);
    const [width, setWidth] = react_1.default.useState(0);
    const node = (0, react_1.useRef)(null);
    const updatePosition = () => {
        if (!node.current) {
            return;
        }
        const { offsetHeight, offsetWidth } = node.current;
        setHeight(offsetHeight);
        setWidth(offsetWidth);
    };
    (0, react_1.useEffect)(() => {
        setTimeout(updatePosition, 0);
    }, []);
    (0, react_1.useEffect)(() => {
        updatePosition();
    }, [props.children]);
    const isStyleCalculationInProgress = width === 0 && height === 0;
    const shouldMove = style.top - height - 5 < scrollTop;
    const top = shouldMove ? style.bottom + 5 : style.top - height - 5;
    const left = clamp(style.left - width / 2, 0, pageBoundingRect.width - width);
    const childrenWithProps = react_1.default.Children.map(children, (child) => 
    // @ts-ignore
    react_1.default.cloneElement(child, {
        onUpdate: () => {
            setHeight(0);
            setWidth(0);
        },
        popup: {
            position: shouldMove ? "below" : "above",
        },
    }));
    return (react_1.default.createElement("div", { className: "PdfHighlighter__tip-container", style: {
            visibility: isStyleCalculationInProgress ? "hidden" : "visible",
            top,
            left,
        }, ref: node }, childrenWithProps));
};
exports.TipContainer = TipContainer;
//# sourceMappingURL=TipContainer.js.map