"use client";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useEffect } from "react";
import { getDocument, GlobalWorkerOptions } from "pdfjs-dist";
export const PdfLoader = (_a) => {
    var { workerSrc = "https://unpkg.com/pdfjs-dist@3.3.122/build/pdf.worker.min.js", url, beforeLoad, children, cMapUrl, cMapPacked, onError } = _a, props = __rest(_a, ["workerSrc", "url", "beforeLoad", "children", "cMapUrl", "cMapPacked", "onError"]);
    const [pdfDocument, setPdfDocument] = React.useState(null);
    const [error, setError] = React.useState(null);
    const documentRef = React.useRef(null);
    useEffect(() => {
        setPdfDocument(null);
        setError(null);
        if (typeof workerSrc === "string") {
            GlobalWorkerOptions.workerSrc = workerSrc;
        }
        Promise.resolve()
            .then(() => pdfDocument && pdfDocument.destroy())
            .then(() => {
            if (!url) {
                return;
            }
            return getDocument(Object.assign({ url,
                cMapUrl,
                cMapPacked }, props))
                .promise.then((pdfDocument) => {
                setPdfDocument(pdfDocument);
            })
                .catch((e) => {
                setError(e);
            });
        })
            .catch((e) => setError(e));
        return () => {
            if (pdfDocument) {
                pdfDocument.destroy();
            }
        };
    }, [url]);
    const renderDocument = () => {
        if (error === null && pdfDocument === null) {
            return beforeLoad;
        }
        else if (error) {
            console.log(error.message);
            return React.createElement("div", { style: { color: "black" } }, error.message);
        }
        else if (pdfDocument !== null && pdfDocument !== undefined) {
            return children(pdfDocument);
        }
        else {
            return null;
        }
    };
    return (React.createElement(React.Fragment, null,
        React.createElement("span", { ref: documentRef }),
        renderDocument()));
};
//# sourceMappingURL=PdfLoader.js.map